################################################################
#
# Program:	pgmdemo/entry12.sh
# Author:	Dana French @ Applied Intelligence Group
# Date:		Aug 05, 1994
#
################################################################
DD_MENU=${DD_MENU:=./}
PRGNUM=${PRGNUM:="demo"}
#
#    If the user selects "Save" on the data entry screen, the value of
#    TORF will be "0"
#
if [ ${TORF} -eq 0 ]
then
#
#    make the screen pretty
#   
   clear
   header
   refresh
#
#    NBRLABS is the number of fields associated with the configuration
#    data entry screen i.e. number of prompts in the "entry12.txt" file.
#   
   NBRLABS=11
#
#    Create the data entry screen record
#   
   mkrecord "${NBRLABS}"
#
#    Create field variables from the data entry screen RECORD
#   
   CNT_ANS="0"
   while [ ${CNT_ANS} -lt ${NBRLABS} ]
   do
       CNT_ANS="$(( ${CNT_ANS} + 1 ))"
       ARRY[${CNT_ANS}]=`echo ${RECORD} | cut -d"|" -f${CNT_ANS}`
   done

#
#    Associate the field variables with Environment variables
#   
   BASETRAN="${ARRY[5]}"
   BASEHOLD="${ARRY[6]}"
   BASECFRM="${ARRY[7]}"
   BASEINCOME="${ARRY[8]}"
#
#    Backup the current "config.sh"
#   
   cp ${DD_MENU}config.sh ${DD_MENU}config.bak
#
#    Zero out the current "config.sh"
#   
   > ${DD_MENU}config.sh
#
#    Output a comment header to "config.sh"
#   
   echo "#########################################################" >> ${DD_MENU}config.sh
   echo "#" >> ${DD_MENU}config.sh
   echo "#	Environment Variables" >> ${DD_MENU}config.sh
   echo "#" >> ${DD_MENU}config.sh
   echo "#########################################################" >> ${DD_MENU}config.sh
#
#    Loop through each field variable and create an associated
#    environment variable in the "config.sh"
#   
   ICNT=0
   while [ ${ICNT} -lt ${NBRLABS} ]
   do
      ICNT=`expr ${ICNT} + 1`
      TMP=`echo ${ARRY[${ICNT}]}`
      case ${ICNT} in
         1) echo "DD_BIN=\"${TMP%%/}/\"" >> ${DD_MENU}config.sh;;
         2) echo "DD_SPOOL=\"${TMP%%/}/\"" >> ${DD_MENU}config.sh;
            echo "DD_TRAN=\"${DD_SPOOL}${BASETRAN%%/}/\"" >> ${DD_MENU}config.sh;
            echo "DD_HOLD=\"${DD_SPOOL}${BASEHOLD%%/}/\"" >> ${DD_MENU}config.sh;
            echo "DD_CFRM=\"${DD_SPOOL}${BASECFRM%%/}/\"" >> ${DD_MENU}config.sh;
            echo "DD_INCOME=\"${DD_SPOOL}${BASEINCOME%%/}/\"" >> ${DD_MENU}config.sh;;
         3) echo "DD_TMP=\"${TMP%%/}/\"" >> ${DD_MENU}config.sh;;
         4) echo "LOGFILE=\"${TMP}\"" >> ${DD_MENU}config.sh;;
         5) echo "BASETRAN=\"${BASETRAN}\"" >> ${DD_MENU}config.sh;;
         6) echo "BASEHOLD=\"${BASEHOLD}\"" >> ${DD_MENU}config.sh;;
         7) echo "BASECFRM=\"${BASECFRM}\"" >> ${DD_MENU}config.sh;;
         8) echo "BASEINCOME=\"${BASEINCOME}\"" >> ${DD_MENU}config.sh;;
         9) echo "MAILID=\"${TMP}\"" >> ${DD_MENU}config.sh;;
         10) echo "SERVNAME=\"${TMP}\"" >> ${DD_MENU}config.sh;;
         11) echo "TIMER=\"${TMP}\"" >> ${DD_MENU}config.sh;;
      esac
   done
#
#    Now reload the new "config.sh" so that changes are implemented
#   
   . ${DD_MENU}config.sh
#
#    Now create and output to new "config.sh" environment variables
#    which are independent of the configuration data entry screen.
#   
   MSG_LOG="${DD_TMP}pgm${PRGNUM}.log"
   touch ${MSG_LOG}
   chmod 666 ${MSG_LOG}
   echo "PRG_ALIAS=\"${PRG_ALIAS}\"" >> ${DD_MENU}config.sh
   echo "MSG_LOG=\"${DD_TMP}pgm${PRGNUM}.log\"" >> ${DD_MENU}config.sh
   echo "ERRMSG=\"Command Line Parameter Not Specified\"" >> ${DD_MENU}config.sh
   echo "MENULEV=1" >> ${DD_MENU}config.sh
   echo "MENUPREV=\${MENULEV}" >> ${DD_MENU}config.sh
   echo "" >> ${DD_MENU}config.sh
   echo "#########################################################" >> ${DD_MENU}config.sh
   echo "#" >> ${DD_MENU}config.sh
   echo "#	MACROS" >> ${DD_MENU}config.sh
   echo "#" >> ${DD_MENU}config.sh
   echo "#########################################################" >> ${DD_MENU}config.sh
   echo "MAC_PARM1=\"if [ \\\"\\\${1}\\\" = \\\"\\\" ]; then errexit \\\${0} \\\"First \\\${ERRMSG}\\\"; fi\"" >> ${DD_MENU}config.sh
   echo "MAC_PARM2=\"if [ \\\"\\\${1}\\\" = \\\"\\\" ]; then errexit \\\${0} \\\"Second \\\${ERRMSG}\\\"; fi\"" >> ${DD_MENU}config.sh
   echo "MAC_PARM3=\"if [ \\\"\\\${1}\\\" = \\\"\\\" ]; then errexit \\\${0} \\\"Third \\\${ERRMSG}\\\"; fi\"" >> ${DD_MENU}config.sh
   echo "MAC_TIME=\"TIMESTAMP=\\\`date +\\\"%y:%m:%d:%H:%M:%S\\\"\\\`\"" >> ${DD_MENU}config.sh
#
#    Inform the user that any associated daemons, which are dependent
#    upon the "config.sh" file, must be restarted in order to reflect
#    the new values.
#   
   mvaddstr $(( ${MAX_LINES} - 2 )) 1 "In order for any changes to be reflected in the ${PRG_ALIAS} daemon,"
   mvaddstr $(( ${MAX_LINES} - 1 )) 1 "you must stop and restart the ${PRG_ALIAS} daemon."

   scrnend
fi

