################################################################
#
# Program:	pgm1301/entry22.sh
# Author:	Dana French @ Applied Intelligence Group
# Date:		Aug 05, 1994
#
################################################################
logmsg()
{
   eval ${MAC_PARM1}
   eval ${MAC_PARM2}
   eval ${MAC_PARM3}

   if [ "_${3}" = "_0" ]
   then
      MSG_NBR="0"
   else
      MSG_NBR=`expr ${MSG_NBR} + 1`
   fi

   if [ ${1} = 0 ]; then
      echo "${TIMESTAMP}|${MSG_NBR}|${MSG_FAILED}|${2}|" >> ${MSG_LOG}
   fi
   if [ ${1} = 1 ]; then
      echo "${TIMESTAMP}|${MSG_NBR}|${MSG_SUCESS}|${2}|" >> ${MSG_LOG}
   fi
}

################################################################
clear
header
move 4 1
refresh
echo ""

DD_TABLE="table${LABDAT}10"
MSG_SUCESS="------"
MSG_FAILED="FAILED"
MSG_LOG="${DD_TMP}entry22.out"
MSG_NBR="0"

rm -f ${MSG_LOG}
ls -1 ${DD_TABLE} | while :
RECLINE=`line`
do
   MACH=`echo ${RECLINE} | cut -d"|" -f1`
   TYPE=`echo ${RECLINE} | cut -d"|" -f2`
   FUNC=`echo ${RECLINE} | cut -d"|" -f3`
   eval ${MAC_TIME}
   logmsg 1 "Creating Dir's for ${MACH}, ${TYPE}, ${FUNC}"  0
   echo "Working on ${DD_TRAN}"
   if [ -d ${DD_TRAN} ]
   then
      logmsg 0 "Directory \"${DD_TRAN}\" already exists" 
   else
      if mkdir ${DD_TRAN} 2>/dev/null
      then
         logmsg 1 "Created Directory \"${DD_TRAN}\"" 
         if chmod 777 ${DD_TRAN}
         then
            logmsg 1 "Permissions on \"${DD_TRAN}\" changed to 777" 
         else
            logmsg 0 "Unable to Change Permissions on \"${DD_TRAN}\"" 
         fi
      else
         logmsg 0 "Unable to create directory \"${DD_TRAN}\"" 
      fi
   fi

   echo "Working on ${DD_TRAN}${MACH}"
   if [ -d ${DD_TRAN}${MACH} ]
   then
      logmsg 0 "Directory \"${DD_TRAN}${MACH}\" already exists" 
   else
      if mkdir ${DD_TRAN}${MACH} 2>/dev/null
      then
         logmsg 1 "Created Directory \"${DD_TRAN}${MACH}\"" 
         if chmod 777 ${DD_TRAN}${MACH}
         then
            logmsg 1 "Permissions on \"${DD_TRAN}${MACH}\" changed to 777" 
         else
            logmsg 0 "Unable to Change Permissions on \"${DD_TRAN}${MACH}\"" 
         fi
      else
         logmsg 0 "Unable to create directory \"${DD_TRAN}${MACH}\"" 
      fi
   fi

   echo "Working on ${DD_TRAN}${MACH}/${TYPE}"
   if [ -d ${DD_TRAN}${MACH}/${TYPE} ]
   then
      logmsg 0 "Directory \"${DD_TRAN}${MACH}/${TYPE}\" already exists" 
   else
      if mkdir ${DD_TRAN}${MACH}/${TYPE} 2>/dev/null
      then
         logmsg 1 "Created Directory \"${DD_TRAN}${MACH}/${TYPE}\"" 
         if chmod 777 ${DD_TRAN}${MACH}/${TYPE}
         then
            logmsg 1 "Permissions on \"${DD_TRAN}${MACH}/${TYPE}\" changed to 777" 
         else
            logmsg 0 "Unable to Change Permissions on \"${DD_TRAN}${MACH}/${TYPE}\"" 
         fi
      else
         logmsg 0 "Unable to create directory \"${DD_TRAN}${MACH}/${TYPE}\"" 
      fi
   fi

   echo "Working on ${DD_TRAN}${MACH}/${TYPE}/${FUNC}"
   if [ -d ${DD_TRAN}${MACH}/${TYPE}/${FUNC} ]
   then
      logmsg 0 "Directory \"${DD_TRAN}${MACH}/${TYPE}/${FUNC}\" already exists" 
   else
      if mkdir ${DD_TRAN}${MACH}/${TYPE}/${FUNC} 2>/dev/null
      then
         logmsg 1 "Created Directory \"${DD_TRAN}${MACH}/${TYPE}/${FUNC}\"" 
         if chmod 777 ${DD_TRAN}${MACH}/${TYPE}/${FUNC}
         then
            logmsg 1 "Permissions on \"${DD_TRAN}${MACH}/${TYPE}/${FUNC}\" changed to 777" 
            if touch ${DD_TRAN}${MACH}/${TYPE}/${FUNC}/${LOGFILE}
            then
               logmsg 1 "Log file created for \"${MACH}/${TYPE}/${FUNC}\"" 
               if chmod 666 ${DD_TRAN}${MACH}/${TYPE}/${FUNC}/${LOGFILE}
               then
                  logmsg 1 "Permissions on \"${MACH}/${TYPE}/${FUNC}\" Log file changed to 666" 
               else
                  logmsg 0 "Unable to change permissions on \"${MACH}/${TYPE}/${FUNC}\" Log file" 
               fi
            else
               logmsg 0 "Unable to create Log file for \"${MACH}/${TYPE}/${FUNC}\"" 
            fi
         else
            logmsg 0 "Unable to Change Permissions on \"${DD_TRAN}${MACH}/${TYPE}/${FUNC}\"" 
         fi
      else
         logmsg 0 "Unable to create directory \"${DD_TRAN}${MACH}/${TYPE}/${FUNC}\"" 
      fi
   fi

   echo "Working on ${DD_HOLD}"
   if [ -d ${DD_HOLD} ]
   then
      logmsg 0 "Directory \"${DD_HOLD}\" already exists" 
   else
      if mkdir ${DD_HOLD} 2>/dev/null
      then
         logmsg 1 "Created Directory \"${DD_HOLD}\"" 
         if chmod 777 ${DD_HOLD}
         then
            logmsg 1 "Permissions on \"${DD_HOLD}\" changed to 777" 
         else
            logmsg 0 "Unable to Change Permissions on \"${DD_HOLD}\"" 
         fi
      else
         logmsg 0 "Unable to create directory \"${DD_HOLD}\"" 
      fi
   fi

   echo "Working on ${DD_HOLD}${MACH}"
   if [ -d ${DD_HOLD}${MACH} ]
   then
      logmsg 0 "Directory \"${DD_HOLD}${MACH}\" already exists" 
   else
      if mkdir ${DD_HOLD}${MACH} 2>/dev/null
      then
         logmsg 1 "Created Directory \"${DD_HOLD}${MACH}\"" 
         if chmod 777 ${DD_HOLD}${MACH}
         then
            logmsg 1 "Permissions on \"${DD_HOLD}${MACH}\" changed to 777" 
         else
            logmsg 0 "Unable to Change Permissions on \"${DD_HOLD}${MACH}\"" 
         fi
      else
         logmsg 0 "Unable to create directory \"${DD_HOLD}${MACH}\"" 
      fi
   fi

   echo "Working on ${DD_HOLD}${MACH}/${TYPE}"
   if [ -d ${DD_HOLD}${MACH}/${TYPE} ]
   then
      logmsg 0 "Directory \"${DD_HOLD}${MACH}/${TYPE}\" already exists" 
   else
      if mkdir ${DD_HOLD}${MACH}/${TYPE} 2>/dev/null
      then
         logmsg 1 "Created Directory \"${DD_HOLD}${MACH}/${TYPE}\"" 
         if chmod 777 ${DD_HOLD}${MACH}/${TYPE}
         then
            logmsg 1 "Permissions on \"${DD_HOLD}${MACH}/${TYPE}\" changed to 777" 
         else
            logmsg 0 "Unable to Change Permissions on \"${DD_HOLD}${MACH}/${TYPE}\"" 
         fi
      else
         logmsg 0 "Unable to create directory \"${DD_HOLD}${MACH}/${TYPE}\"" 
      fi
   fi

   echo "Working on ${DD_HOLD}${MACH}/${TYPE}/${FUNC}"
   if [ -d ${DD_HOLD}${MACH}/${TYPE}/${FUNC} ]
   then
      logmsg 0 "Directory \"${DD_HOLD}${MACH}/${TYPE}/${FUNC}\" already exists" 
   else
      if mkdir ${DD_HOLD}${MACH}/${TYPE}/${FUNC} 2>/dev/null
      then
         logmsg 1 "Created Directory \"${DD_HOLD}${MACH}/${TYPE}/${FUNC}\"" 
         if chmod 777 ${DD_HOLD}${MACH}/${TYPE}/${FUNC}
         then
            logmsg 1 "Permissions on \"${DD_HOLD}${MACH}/${TYPE}/${FUNC}\" changed to 777" 
            if touch ${DD_HOLD}${MACH}/${TYPE}/${FUNC}/${LOGFILE}
            then
               logmsg 1 "Log file created for \"${MACH}/${TYPE}/${FUNC}\"" 
               if chmod 666 ${DD_HOLD}${MACH}/${TYPE}/${FUNC}/${LOGFILE}
               then
                  logmsg 1 "Permissions on \"${MACH}/${TYPE}/${FUNC}\" Log file changed to 666" 
               else
                  logmsg 0 "Unable to change permissions on \"${MACH}/${TYPE}/${FUNC}\" Log file" 
               fi
            else
               logmsg 0 "Unable to create Log file for \"${MACH}/${TYPE}/${FUNC}\"" 
            fi
         else
            logmsg 0 "Unable to Change Permissions on \"${DD_HOLD}${MACH}/${TYPE}/${FUNC}\"" 
         fi
      else
         logmsg 0 "Unable to create directory \"${DD_HOLD}${MACH}/${TYPE}/${FUNC}\"" 
      fi
   fi

   echo "Working on ${DD_CFRM}"
   if [ -d ${DD_CFRM} ]
   then
      logmsg 0 "Directory \"${DD_CFRM}\" already exists" 
   else
      if mkdir ${DD_CFRM} 2>/dev/null
      then
         logmsg 1 "Created Directory \"${DD_CFRM}\"" 
         if chmod 777 ${DD_CFRM}
         then
            logmsg 1 "Permissions on \"${DD_CFRM}\" changed to 777" 
         else
            logmsg 0 "Unable to Change Permissions on \"${DD_CFRM}\"" 
         fi
      else
         logmsg 0 "Unable to create directory \"${DD_CFRM}\"" 
      fi
   fi

   echo "Working on ${DD_CFRM}${MACH}"
   if [ -d ${DD_CFRM}${MACH} ]
   then
      logmsg 0 "Directory \"${DD_CFRM}${MACH}\" already exists" 
   else
      if mkdir ${DD_CFRM}${MACH} 2>/dev/null
      then
         logmsg 1 "Created Directory \"${DD_CFRM}${MACH}\"" 
         if chmod 777 ${DD_CFRM}${MACH}
         then
            logmsg 1 "Permissions on \"${DD_CFRM}${MACH}\" changed to 777" 
         else
            logmsg 0 "Unable to Change Permissions on \"${DD_CFRM}${MACH}\"" 
         fi
      else
         logmsg 0 "Unable to create directory \"${DD_CFRM}${MACH}\"" 
      fi
   fi

   echo "Working on ${DD_CFRM}${MACH}/${TYPE}"
   if [ -d ${DD_CFRM}${MACH}/${TYPE} ]
   then
      logmsg 0 "Directory \"${DD_CFRM}${MACH}/${TYPE}\" already exists" 
   else
      if mkdir ${DD_CFRM}${MACH}/${TYPE} 2>/dev/null
      then
         logmsg 1 "Created Directory \"${DD_CFRM}${MACH}/${TYPE}\"" 
         if chmod 777 ${DD_CFRM}${MACH}/${TYPE}
         then
            logmsg 1 "Permissions on \"${DD_CFRM}${MACH}/${TYPE}\" changed to 777" 
         else
            logmsg 0 "Unable to Change Permissions on \"${DD_CFRM}${MACH}/${TYPE}\"" 
         fi
      else
         logmsg 0 "Unable to create directory \"${DD_CFRM}${MACH}/${TYPE}\"" 
      fi
   fi

   echo "Working on ${DD_CFRM}${MACH}/${TYPE}/${FUNC}"
   if [ -d ${DD_CFRM}${MACH}/${TYPE}/${FUNC} ]
   then
      logmsg 0 "Directory \"${DD_CFRM}${MACH}/${TYPE}/${FUNC}\" already exists" 
   else
      if mkdir ${DD_CFRM}${MACH}/${TYPE}/${FUNC} 2>/dev/null
      then
         logmsg 1 "Created Directory \"${DD_CFRM}${MACH}/${TYPE}/${FUNC}\"" 
         if chmod 777 ${DD_CFRM}${MACH}/${TYPE}/${FUNC}
         then
            logmsg 1 "Permissions on \"${DD_CFRM}${MACH}/${TYPE}/${FUNC}\" changed to 777" 
            if touch ${DD_CFRM}${MACH}/${TYPE}/${FUNC}/${LOGFILE}
            then
               logmsg 1 "Log file created for \"${MACH}/${TYPE}/${FUNC}\"" 
               if chmod 666 ${DD_CFRM}${MACH}/${TYPE}/${FUNC}/${LOGFILE}
               then
                  logmsg 1 "Permissions on \"${MACH}/${TYPE}/${FUNC}\" Log file changed to 666" 
               else
                  logmsg 0 "Unable to change permissions on \"${MACH}/${TYPE}/${FUNC}\" Log file" 
               fi
            else
               logmsg 0 "Unable to create Log file for \"${MACH}/${TYPE}/${FUNC}\"" 
            fi
         else
            logmsg 0 "Unable to Change Permissions on \"${DD_CFRM}${MACH}/${TYPE}/${FUNC}\"" 
         fi
      else
         logmsg 0 "Unable to create directory \"${DD_CFRM}${MACH}/${TYPE}/${FUNC}\"" 
      fi
   fi

   echo "Working on ${DD_INCOME}"
   if [ -d ${DD_INCOME} ]
   then
      logmsg 0 "Directory \"${DD_INCOME}\" already exists" 
   else
      if mkdir ${DD_INCOME} 2>/dev/null
      then
         logmsg 1 "Created Directory \"${DD_INCOME}\"" 
         if chmod 777 ${DD_INCOME}
         then
            logmsg 1 "Permissions on \"${DD_INCOME}\" changed to 777" 
         else
            logmsg 0 "Unable to Change Permissions on \"${DD_INCOME}\"" 
         fi
      else
         logmsg 0 "Unable to create directory \"${DD_INCOME}\"" 
      fi
   fi

   echo "Working on ${DD_INCOME}${MACH}"
   if [ -d ${DD_INCOME}${MACH} ]
   then
      logmsg 0 "Directory \"${DD_INCOME}${MACH}\" already exists" 
   else
      if mkdir ${DD_INCOME}${MACH} 2>/dev/null
      then
         logmsg 1 "Created Directory \"${DD_INCOME}${MACH}\"" 
         if chmod 777 ${DD_INCOME}${MACH}
         then
            logmsg 1 "Permissions on \"${DD_INCOME}${MACH}\" changed to 777" 
         else
            logmsg 0 "Unable to Change Permissions on \"${DD_INCOME}${MACH}\"" 
         fi
      else
         logmsg 0 "Unable to create directory \"${DD_INCOME}${MACH}\"" 
      fi
   fi

   echo "Working on ${DD_INCOME}${MACH}/${TYPE}"
   if [ -d ${DD_INCOME}${MACH}/${TYPE} ]
   then
      logmsg 0 "Directory \"${DD_INCOME}${MACH}/${TYPE}\" already exists" 
   else
      if mkdir ${DD_INCOME}${MACH}/${TYPE} 2>/dev/null
      then
         logmsg 1 "Created Directory \"${DD_INCOME}${MACH}/${TYPE}\"" 
         if chmod 777 ${DD_INCOME}${MACH}/${TYPE}
         then
            logmsg 1 "Permissions on \"${DD_INCOME}${MACH}/${TYPE}\" changed to 777" 
         else
            logmsg 0 "Unable to Change Permissions on \"${DD_INCOME}${MACH}/${TYPE}\"" 
         fi
      else
         logmsg 0 "Unable to create directory \"${DD_INCOME}${MACH}/${TYPE}\"" 
      fi
   fi

   echo "Working on ${DD_INCOME}${MACH}/${TYPE}/${FUNC}"
   if [ -d ${DD_INCOME}${MACH}/${TYPE}/${FUNC} ]
   then
      logmsg 0 "Directory \"${DD_INCOME}${MACH}/${TYPE}/${FUNC}\" already exists" 
   else
      if mkdir ${DD_INCOME}${MACH}/${TYPE}/${FUNC} 2>/dev/null
      then
         logmsg 1 "Created Directory \"${DD_INCOME}${MACH}/${TYPE}/${FUNC}\"" 
         if chmod 777 ${DD_INCOME}${MACH}/${TYPE}/${FUNC}
         then
            logmsg 1 "Permissions on \"${DD_INCOME}${MACH}/${TYPE}/${FUNC}\" changed to 777" 
            if touch ${DD_INCOME}${MACH}/${TYPE}/${FUNC}/${LOGFILE}
            then
               logmsg 1 "Log file created for \"${MACH}/${TYPE}/${FUNC}\"" 
               if chmod 666 ${DD_INCOME}${MACH}/${TYPE}/${FUNC}/${LOGFILE}
               then
                  logmsg 1 "Permissions on \"${MACH}/${TYPE}/${FUNC}\" Log file changed to 666" 
               else
                  logmsg 0 "Unable to change permissions on \"${MACH}/${TYPE}/${FUNC}\" Log file" 
               fi
            else
               logmsg 0 "Unable to create Log file for \"${MACH}/${TYPE}/${FUNC}\"" 
            fi
         else
            logmsg 0 "Unable to Change Permissions on \"${DD_INCOME}${MACH}/${TYPE}/${FUNC}\"" 
         fi
      else
         logmsg 0 "Unable to create directory \"${DD_INCOME}${MACH}/${TYPE}/${FUNC}\"" 
      fi
   fi

done

if touch ${DD_SPOOL}${LOGFILE}
then
   logmsg 1 "Log file created for \"${DD_SPOOL}\"" 
   if chmod 666 ${DD_SPOOL}${LOGFILE}
   then
      logmsg 1 "Permissions on \"${DD_SPOOL}${LOGFILE}\" changed to 666" 
   else
      logmsg 0 "Unable to change permissions on \"${DD_SPOOL}${LOGFILE}\"" 
   fi
else
   logmsg 0 "Unable to create Log file for \"${DD_SPOOL}${LOGFILE}\"" 
fi

${CMD_LISTER} ${MSG_LOG}
rm -f ${MSG_LOG}
MSG_LOG="${DD_TMP}pgm${PRGNUM}.log"
scrnend

