################################################################
#
# Program:	pgm1301/entry61.sh
# Author:	Dana French @ Applied Intelligence Group
# Date:		Aug 05, 1994
#
################################################################
clear
header
move 4 1
refresh
echo ""

TMP_FILE="/tmp/${RANDOM}"
PRT_FILE="/tmp/${RANDOM}"
header > ${PRT_FILE}
sort -t"|" +1.0 -2.0 +0.0 -1.0 /usr/pub/spool/Log > ${TMP_FILE}

RECPP=19
NREC=`wc -l ${TMP_FILE} | sed -e "s/ /|/g;s/	/|/g;s/||/|/g;s/||/|/g;s/||/|/g;s/||/|/g;s/||/|/g;s/||/|/g;s/||/|/g;s/||/|/g;s/^|//g" | cut -d"|" -f1`
NPAGES=`expr ${NREC} / ${RECPP} + 1`
ICNT=0
PGCNT=0
PGNUM=1

echo "                                     Page ${PGNUM}"
while [ ${ICNT} -lt ${NREC} ]
do
    ICNT=`expr ${ICNT} + 1`
    PGCNT=`expr ${PGCNT} + 1`
    if [ ${PGCNT} -gt ${RECPP} ]
    then
        echo "                                 Page ${PGNUM} of ${NPAGES}" >> ${PRT_FILE}
        echo "" >> ${PRT_FILE}
        header >> ${PRT_FILE}
        clear
        header
        PGCNT=0
        PGNUM=`expr ${PGNUM} + 1`
        echo "                                     Page ${PGNUM}"
    fi
    echo "Working on record ${ICNT} of ${NREC}\c"
    REC_LINE=`line`
    echo ".\c"
    TEMP=`echo ${REC_LINE} | cut -d"|" -f1`
    echo ".\c"
    YEAR=`echo ${TEMP} | cut -d":" -f1`
    echo ".\c"
    MONTH=`echo ${TEMP} | cut -d":" -f2`
    echo ".\c"
    DAY=`echo ${TEMP} | cut -d":" -f3`
    echo ".\c"
    HOUR=`echo ${TEMP} | cut -d":" -f4`
    echo ".\c"
    MINUTE=`echo ${TEMP} | cut -d":" -f5`
    echo ".\c"
    SECOND=`echo ${TEMP} | cut -d":" -f6`
    echo ".\c"

    TEMP=`echo ${REC_LINE} | cut -d"|" -f2`
    echo ".\c"
    DIVNAME=`echo ${TEMP} | cut -d":" -f1`
    echo ".\c"
    FILEFUNC=`echo ${TEMP} | cut -d":" -f2`
    echo ".\c"
    FILETYPE=`echo ${TEMP} | cut -d":" -f3`
    echo ".\c"
    FILENAME=`echo ${TEMP} | cut -d":" -f4`
    echo ".\c"
    
    STATUS=`echo ${REC_LINE} | cut -d"|" -f3`
    echo ".\c"
    MESG=`echo ${REC_LINE} | cut -d"|" -f4`
    echo ".\c"

    echo "${MONTH}/${DAY}/${YEAR} ${HOUR}:${MINUTE}:${SECOND}	${MESG}" >> ${PRT_FILE}
    echo ".\c"
    echo "${STATUS}	${DIVNAME}		${FILETYPE}		${FILEFUNC}		${FILENAME}\n" >> ${PRT_FILE}
    echo "."

done < ${TMP_FILE}
rm -f ${TMP_FILE}

PGCNT=`expr ${PGCNT} + 1`
while [ ${PGCNT} -lt ${RECPP} ]
do 
    PGCNT=`expr ${PGCNT} + 1`
    echo "\n\n" >> ${PRT_FILE}
done
echo "                                 Page ${PGNUM} of ${NPAGES}" >> ${PRT_FILE}
echo "" >> ${PRT_FILE}

echo "\nOutput to (S)creen, (P)rinter or (B)oth ? \c"
read TMP
if [ "_${TMP}" = "_b" -o "_${TMP}" = "_B" ]
then
    ${CMD_PRINTER} ${PRT_FILE}
    scrnend
    clear
    ${CMD_LISTER} ${PRT_FILE}
elif [ "_${TMP}" = "_p" -o "_${TMP}" = "_P" ]
then
    ${CMD_PRINTER} ${PRT_FILE}
else
    clear
    ${CMD_LISTER} ${PRT_FILE}
fi
scrnend
rm -f ${PRT_FILE}

