#############################################################
#### DO NOT REMOVE #### DO NOT REMOVE #### DO NOT REMOVE ####
#############################################################
#
#  This header is the only compensation I receive for this
#  script.  Please do not remove it.
#
#############################################################
# Program:	frenchMenus.sh
#               Copyright 1995
#
# Description:	Korn shell menuing functions script.  
#               This set of functions provides a generic
#               menuing/data entry system using the Shell
#               curses screen addressing system.
#
# Author:	Dana French (dfrench@vialink.com)
#		Applied Intelligence Group
#		(405) 341-7700
#
# Date:		10/10/95
#
#############################################################
#### DO NOT REMOVE #### DO NOT REMOVE #### DO NOT REMOVE ####
#############################################################
# Modifications:
#
# 11/22/95	Rewrote the curses demo into this set of functions.
#
# 11/20/95	ksh modifications by Kevin Howard (kjh@plaza.ds.adp.com)
#               were incorporated into the demo program.
#
# 10/18/95	Original code		Version: 1.0
################################################################################
cnt_sleep()
{
   move ${MAX_LINES} 1
   clrtoeol
   attrset blink
   attrset rev
   addstr "Sleeping for ${1} second(s)"
   attroff
   refresh
   SLEEP_CNT="0"
   while [ ${SLEEP_CNT} -lt ${1} ]
   do
       SLEEP_CNT="$(( ${SLEEP_CNT} + 1 ))"
       addstr "."
       refresh
       sleep 1
   done
   mvclrtoeol ${MAX_LINES} 1
   refresh
}
################################################################################
scrnend()
{
   move ${MAX_LINES} 1
   clrtoeol
   attrset blink
   attrset rev
   addstr "Press <ENTER> to contine"
   attroff
   refresh
   SCRNEND=`getch`
}
################################################################################
errend()
{
   move "$(( ${MAX_LINES} - 1 ))"  1
   clrtoeol
   addstr "ERROR: ${1}"
   scrnend
}
################################
invalidKey()
{
    putMessage "ERROR: Invalid keystroke..."
    sleep 2
    return 0
}
################################
yesOrNo()
{
    TORF="0"
    putMessage "${1}..." "(Y/N)?"
    YORN=`getch`
    case _${YORN} in
        "_Y") TORF="0";;
        "_y") TORF="0";;
        "_N") TORF="1";;
        "_n") TORF="1";;
           *) TORF="1";;
    esac
    putMessage
    return ${TORF}
}
################################
putMessage()
{
    move ${MAX_LINES} 1
    clrtoeol
    attrset blink
    addstr "${1}"
    attroff
    addstr "${2}"
    refresh
}
################################
justifyCenter()
{
    eval mvaddstr \${1} \"$(( $(( ${MAX_COLS} - ${#2} )) / 2 ))\" \"${2}\"
}
################################
justifyLeft()
{
    eval mvaddstr \${1} \"$(( ${MAX_COLS} - ${#2} ))\" \"${2}\"
}
################################
header()
{
   SCRNUM="${LABEL}"
   [ "_${SCRDATE}" = "_" ] && SCRDATE=`date +"%m/%d/%y"`
   [ "_${SERVER}" = "_" ] && SERVER="${LOGNAME}@`uname -n`"
   attrset rev
   mvaddstr 1 1 "PGM${PRGNUM}"
   justifyCenter 1 "${HDRLIN1}"
   justifyLeft 1 "${SERVER}"
   mvaddstr 2 1 "SCR${SCRNUM}"
   justifyCenter 2 "${HDRLIN2}"
   justifyLeft 2 "${SCRDATE}"
   attroff
}
###############################
fillcol()
{
    LEN_DIFF="$(( ${3} - $(( ${#1} + ${#2} )) ))"
    typeset -L${LEN_DIFF} DOTS="................................................................................"
    ${CMD_ECHO} "${1}${DOTS}(${2})"
}
###############################
drawMenu()
{
    CNT_DRAW=0
    CNT_LINE=0
    while LAB_RAW=`getstr`
    do
        CNT_DRAW="$(( ${CNT_DRAW} + 1 ))"
        ${CMD_ECHO} "${LAB_RAW}" | IFS="|" read LAB_FILL M_DFLT
        eval M_${LABEL}_${CNT_DRAW}=\"${M_DFLT}\"
        CNT_LINE="$(( ${CNT_DRAW} \* 2 ))"
        COL_DRAW="26"
        [ ${CNT_DRAW} -ge 10 ] && COL_DRAW="25"
        mvaddstr "$(( 3 + ${CNT_LINE} ))" ${COL_DRAW} "${CNT_DRAW} = ${LAB_FILL}"
    done < ${DD_TOPDIR}/menu${1}.txt
    LAB_PROMPT=`fillcol "Select Menu Option" "0" 32`
    mvaddstr "$(( ${CNT_LINE} + 6 ))" 5 "${LAB_PROMPT}:"
    clrtoeol
    refresh
    return ${CNT_DRAW}
}
###############################
drawEntry()
{
    CNT_DRAW=0
    while LAB_RAW=`getstr`
    do
        CNT_DRAW="$(( ${CNT_DRAW} + 1 ))"
        ${CMD_ECHO} "${LAB_RAW}" | IFS="|" read LAB_FILL E_TMP
        eval E_DFLT=\"${E_TMP}\"
        eval E_${LABEL}_${CNT_DRAW}=\"\${E_DFLT}\"
        LAB_PROMPT=`fillcol "${LAB_FILL}" "${E_DFLT}" 37`
        COL_DRAW="2"
        [ ${CNT_DRAW} -ge 10 ] && COL_DRAW="1"
        mvaddstr "$(( 4 + ${CNT_DRAW} ))" ${COL_DRAW} "${CNT_DRAW}: ${LAB_PROMPT}:"
    done < ${DD_TOPDIR}/entry${1}.txt
    NBR_LINES="${CNT_DRAW}"
    CNT_DRAW="$(( ${NBR_LINES} + 1 ))"
    COL_DRAW="2"
    [ ${CNT_DRAW} -ge 10 ] && COL_DRAW="1"
    CNT_LINE="$(( ${NBR_LINES} + 6 ))"
    eval mvaddstr \${CNT_LINE} \${COL_DRAW} \"`fillcol "${CNT_DRAW}: Line to Change" "0" 40`:\"
    clrtoeol
    putMessage
    return ${NBR_LINES}
}
###############################
putAnswer()
{
    putMessage "Processing user data..."
    CNT_ANS="0"
    while [ ${CNT_ANS} -lt ${1} ]
    do
        CNT_ANS="$(( ${CNT_ANS} + 1 ))"
        move "$(( 4 + ${CNT_ANS} ))" 46
        clrtoeol
        addstr "${ANS[${CNT_ANS}]}"
        refresh
    done
    putMessage
}
###############################
getMenu()
{
    while :
    do
        CNT_ANS="0"
        move "$(( ${1} \* 2 + 6 ))" 41
        clrtoeol
        refresh
        LTC=`getstr`
        [ "_${LTC}" = "_" ] && LTC="0"
        [ "_${LTC}" = "_0" ] && reset_level && return ${LTC}
        expr ${LTC} + 0 > ${DEV_NULL} 2>&1 || continue
        [ ${LTC} -lt 0 ] && cnt_sleep "$(( ${LTC} \* -1 ))"
        [ ${LTC} -lt 0 -o ${LTC} -gt ${1} ] && continue
        break
    done
    set_level ${LTC}
    return ${LTC}
}
###############################
getAnswer()
{
    STATUS="0"
    eval FUNCTION="\${M_${LABDAT}_${LTC}}"
    if [ "_${FUNCTION}" = "_modify" -o "_${FUNCTION}" = "_delete" ]
    then
        selectRecord "${1}"
        STATUS="${?}"
        return ${STATUS}
    fi                

    CNT_ANS="0"
    while [ ${CNT_ANS} -lt ${1} ]
    do
        CNT_ANS="$(( ${CNT_ANS} + 1 ))"
        move "$(( 4 + ${CNT_ANS} ))" 46
        refresh
        ANS=`getstr`
        eval ANS\[\${CNT_ANS}\]=\"${ANS}\"
    done
    return ${STATUS}
}
###############################
resetAnswer()
{
    mkrecord "${1}"
    if [ "_${FUNCTION}" = "_delete" ]
    then
        removeRecord "table${LABDAT}0"
        return 0
    fi
    RECORD_OLD="${RECORD}"
    while :
    do
        mvclrtoeol "$(( ${1} + 6 ))" 46
        refresh
        LTC=`getstr`
        [ "_${LTC}" = "_" ] && LTC="0"
        [ "_${LTC}" = "_0" ] && mkrecord "${1}" && break
        expr ${LTC} + 0 > ${DEV_NULL} 2>&1 || continue
        if [ ${LTC} -eq -1 ]
        then
            LTC="$(( ${1} + 1 ))"
            refresh "e${LABEL}"
            putAnswer ${1}
        fi
        [ ${LTC} -ge 1 -a ${LTC} -le ${1} ] \
        && mvclrtoeol "$(( 4 + ${LTC} ))" 46 \
        && refresh \
        && ANS=`getstr` \
        && eval ANS\[\${LTC}\]=\"${ANS}\"
    done
    if [ "_${RECORD}" != "_${RECORD_OLD}" -o "_${FUNCTION}" != "_modify" ]
    then
        if saveRecord "table${LABDAT}0"
        then
            RECORD="${RECORD_OLD}"
            [ "_${FUNCTION}" = "_modify" ] && removeRecord "table${LABDAT}0"
        fi
    else
	attrset rev
	attrset blink
        mvaddstr ${MAX_LINES} 1 "Record is unchanged"
        refresh
        sleep 2
	attroff
        refresh
    fi
    return 0
}
###############################
mkrecord()
{
    putMessage "Assembling data record..."
    RECORD=""
    CNT_ANS="0"
    while [ ${CNT_ANS} -lt ${1} ]
    do
        CNT_ANS="$(( ${CNT_ANS} + 1 ))"
        ANS="${ANS[${CNT_ANS}]}"
        eval E_DFLT=\"\${E_${LABEL}_${CNT_ANS}}\"
        [ "_${ANS}" = "_" ] && ANS="${E_DFLT}"
        RECORD="${RECORD}${ANS}|"
    done
    putMessage
}
###############################
getRecord()
{
    putMessage "Retrieving data record..."
    RECORD=""
    CNT_ANS="0"

    IFS="|"
    for FIELD in `echo "${1}"`
    do
        CNT_ANS="$(( ${CNT_ANS} + 1 ))"
        ANS[${CNT_ANS}]="${FIELD}"
        IFS="|"
    done
    IFS="${IFS_NORM}"
    putMessage
    return ${CNT_ANS}
}
###############################
selectRecord()
{
    STATUS="1"
    putMessage "Retrieving list of data records..."
    IFS=${IFS_CR}
    for RECORD in `ls -1 ${DD_DATABASE}table${LABDAT}0 | sed -e "s|${DD_DATABASE}table${LABDAT}0/||g" -e "s|\\\\\|/|g"`
    do
        IFS=${IFS_NORM}
        getRecord "${RECORD}"
        putAnswer "${1}"
        [ "_${FUNCTION}" = "_modify" ] && TMP="Modify"
        [ "_${FUNCTION}" = "_delete" ] && TMP="Delete"
        if yesOrNo "${TMP} this record"
        then
            STATUS="0"
            break
        fi
        IFS=${IFS_CR}
    done
    IFS=${IFS_NORM}

    putMessage
    return ${STATUS}
}
#############################################################
saveRecord()
{
    STATUS=1
    if yesOrNo "Save Record"
    then
        [ ! -d ${DD_DATABASE}${1} ] && mkdir ${DD_DATABASE}${1} && chmod 777 ${DD_DATABASE}${1}
        [ ! -d ${DD_DATABASE}${1} ] && mkdir ${DD_DATABASE}${1} && chmod 777 ${DD_DATABASE}${1}
        touch ${DD_DATABASE}${1}/`${CMD_ECHO} ${RECORD} | sed -e "s|\/|\\\\\|g;s| |_|g"`
        STATUS="${?}"
    fi
    return ${STATUS}
}
#############################################################
removeRecord()
{
    rm ${DD_DATABASE}${1}/`${CMD_ECHO} ${RECORD} | sed -e "s/\//\\\\\/g;s/ /_/g"`
    STATUS="${?}"
    return ${STATUS}
}
###############################
entryScreen()
{
    eval BUF_TMP=\"\${e${LABEL}:=\"\"}\"
    if [ "${BUF_TMP}" ]
    then
        refresh "e${LABEL}"
        NBR_LINES="${LIN_[${LABEL}]}"
     else
        putMessage "Assembling data entry screen..."
        savescr ${DEV_NULL}
        clear
        header
        drawEntry "${1}"
        NBR_LINES="${?}"
        LIN_[${LABEL}]="${NBR_LINES}"
        savescr e${LABEL}
    fi
    getAnswer ${NBR_LINES} && resetAnswer ${NBR_LINES}
    putMessage
    return 0
}
###############################
set_level()
{
   MENUPREV=${MENULEV}
   MENULEV="$(( ${MENULEV} + 1 ))"
   MENUNEXT="$(( ${MENULEV} + 1 ))"
   MENUANS[${MENULEV}]="${1}"
   set_label
   return 0
}

###############################
reset_level()
{
   MENULEV="$(( ${MENULEV} - 1 ))"
   MENUPREV="$(( ${MENULEV} -  1 ))"
   MENUNEXT="$(( ${MENULEV} + 1 ))"
   [ ${MENUPREV} -le 0 ] && MENUPREV="0"
   set_label
   return 0
}
###############################
set_label()
{
   LABEL=""
   LABDAT=""
   ISFL=0
   if [ ${MENULEV} -ge 1 ]
   then
      while [ ${ISFL} -le ${MENUPREV} ]
      do
         ISFL="$(( ${ISFL} + 1 ))"
         LABEL="${LABEL}${MENUANS[${ISFL}]}"
         [ ${ISFL} -le ${MENUPREV} ] && LABDAT="${LABEL}"
      done
   fi
}
###############################
frenchMenus()
{
    initscr
    MENULEV="0"
    LABEL=""
    SERVER=""
    SCRDATE=""
    HDRSAV0=${HDRLIN2}

    eval MENUANS${MENULEV}=""
    while :
    do
        putMessage "Assembling menu screen..."
        eval BUF_TMP=\"\${m${LABEL}:=\"\"}\"
        if [ "${BUF_TMP}" ]
        then
            refresh "m${LABEL}"
            STATUS="${LIN_[${LABEL}]}"
         else
            savescr ${DEV_NULL}
            clear
            header
            drawMenu "${LABEL}"
            STATUS=${?}
            LIN_[${LABEL}]="${STATUS}"
            savescr "m${LABEL}"
        fi
        getMenu ${STATUS}
        [ ${MENULEV} -lt 0 ] && break
        SH_MENU="${DD_TOPDIR}/menu${LABEL}.sh"
        SH_ENTRY="${DD_TOPDIR}/entry${LABEL}.sh"
        TXT_MENU="${DD_TOPDIR}/menu${LABEL}.txt"
        TXT_ENTRY="${DD_TOPDIR}/entry${LABEL}.txt"
        [ -f ${SH_MENU} ] && . ${SH_MENU} ${LABEL}
        [ -f ${TXT_MENU} ] && continue
        [ -f ${TXT_ENTRY} ] && entryScreen "${LABEL}"
        [ -s ${SH_ENTRY} ] && . ${SH_ENTRY}
        reset_level
    done

    putMessage
}    
###############################
